@echo off

set executable=qbw32.exe
set executable2=qbw32.exe
set dllfilename=TerminalDownloadTool


echo "Terminal Download tool fixer. Current date time = "
date /T
time /T

FOR /f %%a IN ('WMIC OS GET LocalDateTime ^| FIND "."') DO SET DTS=%%a
SET CurrentDateTime=%DTS:~0,4%-%DTS:~4,2%-%DTS:~6,2%_%DTS:~8,2%-%DTS:~10,2%-%DTS:~12,2%
echo "CurrentDateTime = %CurrentDateTime%"


SET ProgFiles86Root=%ProgramFiles(x86)%
IF NOT "%ProgFiles86Root%"=="" GOTO amd64
SET ProgFiles86Root=%ProgramFiles%

:amd64
SET CommonFilesFolder=%ProgFiles86Root%\Common Files\Intuit\QuickBooks
echo "Path to common files of our interest = %CommonFilesFolder%"


if exist "%CommonFilesFolder%\%dllfilename%.dll" (
    echo "The file [%CommonFilesFolder%\%dllfilename%.dll] was found... continuing..."
) else (
	echo ''
	echo ''
	echo ''
    echo "The file [%CommonFilesFolder%\%dllfilename%.dll] was NOT found. Error. Cannot continue"
    goto theend
)


echo "Following is the list of running processes (%executable%) that we care about."
tasklist /FO Table  /FI "IMAGENAME eq %executable%" /NH


echo "Confirming with the user if they want to continue..."
echo ''
SET /P AREYOUSURE=This'll try to terminate any running Quick Books. Any unsaved work might be lost. Are you sure (Y/[N])?
IF /I "%AREYOUSURE%" NEQ "Y" GOTO userquit

goto stopprocess

:userquit
echo "User chose to not continue. Exiting...."
goto theend


:stopprocess
echo "-------- Now trying to stop them -----------"

for /F "tokens=2 delims= " %%P IN ('tasklist /FO Table /FI "IMAGENAME eq %executable%" /NH') DO (taskkill /f /PID %%P)
tskill "%executable%"


echo "Verifying that QuickBooks is NOT running"
for /F "tokens=*" %%P IN ('tasklist /FO Table /FI "IMAGENAME eq %executable2%"') DO (set ChkOutput=%%P)
echo "Running instance found = %ChkOutput%"

REM IF "%ChkOutput%"=="" GOTO allclear

set Ss1=No tasks are running which match the
call set NoMatch=%%ChkOutput:%Ss1%=%%

REM echo Ms:       %ChkOutput%
REM echo Ss1:      %Ss1%
echo "NoMatch value: %NoMatch%"

If NOT "%ChkOutput%"=="%NoMatch%" (
     GOTO allclear
) else (
     GOTO stillrunning
)


:stillrunning
echo ''
echo ''
echo ''
echo "Running instances of QuickBooks was still found. Failed..."
GOTO theend

:allclear
echo "Now we attempt to make a backup copy of the tdtool file. File = %CommonFilesFolder%\%dllfilename%.dll ;; Backup = %CommonFilesFolder%\%dllfilename%_%CurrentDateTime%.dll"

copy "%CommonFilesFolder%\%dllfilename%.dll" "%CommonFilesFolder%\%dllfilename%_%CurrentDateTime%.dll"

echo "Now we attempt to delete the DLL file: File = %CommonFilesFolder%\%dllfilename%"

del /f /q "%CommonFilesFolder%\TerminalDownloadTool.dll"


if exist "%CommonFilesFolder%\%dllfilename%.dll" (
    echo "The file [%CommonFilesFolder%\%dllfilename%.dll] still exists. Operation failed."
) else (
	echo ''
	echo ''
	echo ''
    echo "Success all done. Please restart the Quick Books in which you encountered the problem."    
)

:theend

echo ''
echo ''

pause